(function ($) {
    'use strict';
    var methods = {
        init: function (params) {
            var self = this, tree, closed, opened, nochild, selected, m_select, filter, open, col_ex, the_width, the_height, the_color;
            if (typeof params[0].data != 'undefined') tree = params[0].data; else  tree = [];
            if (typeof params[0].closed != 'undefined') closed = params[0].closed; else  closed = "closed";
            if (typeof params[0].opened != 'undefined') opened = params[0].opened; else  opened = "opened";
            if (typeof params[0].nochild != 'undefined') nochild = params[0].nochild; else  nochild = "nochild";
            if (typeof params[0].selected != 'undefined') selected = params[0].selected; else  selected = "selected";
            if (typeof params[0].m_select != 'undefined') m_select = params[0].m_select; else  m_select = true;
            if (typeof params[0].filter != 'undefined') filter = params[0].filter; else  filter = true;
            if (typeof params[0].open_close != 'undefined') open = params[0].open_close; else  open = false;
            if (typeof params[0].col_ex != 'undefined') col_ex = params[0].col_ex; else  col_ex = true;
            if (typeof params[0].width != 'undefined') the_width = params[0].width; else  the_width = 400;
            if (typeof params[0].height != 'undefined') the_height = params[0].height; else  the_height = 400;
            if (typeof params[0].color != 'undefined') the_color = params[0].color; else  the_color = "black";
            var classes = {closed: closed, opened: opened, nochild: nochild, selected: selected};
            methods.draw(self, filter, classes, tree, open, col_ex, m_select, the_width, the_height, the_color);
            if (tree.length == '0') {
                console.error('Your array is empty!');
                $(self).find('.brick-tree-filter').append('<div style="color: red">No Data!</div>');
            }
            if (the_width < 100) {
                console.error('The width is small from 250px');
                the_width = '100px';
            } else {
                the_width = the_width + "px";
            }
            if (the_height < 100) {
                console.error('The height is small from 250px');
                the_height = '100px';
            } else {
                the_height = the_height + "px";
            }
        },
        draw: function (self, filter, classes, tree, is_open, col_ex, m_select, the_width, the_height, the_color) {
            self.empty();
            self.append("<div class='be-first-cont'></divclass>");
            self.append("<div class='brick-tree-backup'><input type='hidden' value='" + JSON.stringify(tree) + "'></div>");
            if (filter === true) {
                $(self).find('.be-first-cont').append("<div class='brick-tree-filter'></div>");
                methods.drawInput(self, the_width, the_height, the_color);
            }
            $(self).find('.be-first-cont').append("<div class='brick-tree'></div>");
            $(self).find('.be-first-cont').css({'width': the_width});
            $(self).find('.be-first-cont').css({'height': the_height});
            var inp_width = the_width - 18;
            $(self).find('input').css({'width': '100%'});
            methods.drawTree(self, classes, '', is_open, col_ex, m_select, the_color);
            $(self).find('.opened').css({'background-color': the_color});
            $(self).find('.closed').css({'background-color': the_color});
            $(self).find('.nochild').css({'background-color': the_color});
            $(self).find('.selected').css({'background-color': the_color});
            self.find(".brick-tree-filter").children("form").children("input[name='tree-filter']").on("input", function () {
                methods.drawTree(self, classes, $(this).val(), true, col_ex, m_select, the_color);
                if ($('.tree-icon').hasClass(classes.closed)) {
                    $('.tree-icon').removeClass(classes.closed).addClass(classes.opened);
                    $('.tree-icon').parent().siblings().slideDown();
                }
                else if ($(this).hasClass(classes.opened)) {
                    $('.tree-icon').removeClass(classes.opened).addClass(classes.closed);
                    $('.tree-icon').parent().siblings().slideUp();
                }
                console.log($('.be_tree input').length);
                if ($('.be_tree input').val().length == 2) {
                } else {
                    $('.be_tree input').css("background", "none");
                }
                $(self).find('.opened').css({'background-color': the_color});
                $(self).find('.closed').css({'background-color': the_color});
                $(self).find('.nochild').css({'background-color': the_color});
                $(self).find('.selected').css({'background-color': the_color});
            });
        },
        drawInput: function (self, classes) {
            var html = "<form><input name='tree-filter' type='search'></form>";
            self.find(".brick-tree-filter").append(html);
        },
        drawTree: function (self, classes, filter, is_open, col_ex, m_select, the_color) {
            var filter_low = filter.toLowerCase();
            var html = "";
            var temporary = JSON.parse(self.find(".brick-tree-backup").children("input").val(), 10);
            var filtered = [];
            var j = 0;
            for (var i = 0; i < temporary.length; i++) {
                var tree_item_low = temporary[i].name.toLowerCase();
                if (tree_item_low.indexOf(filter_low) > -1) {
                    filtered[j] = temporary[i];
                    j++;
                }
                else {
                    for (var x = 0; x < temporary.length; x++)
                        if (temporary[x].parent_id == temporary[i].id)
                            temporary[x].parent_id = temporary[i].parent_id;
                    for (var y = 0; y < filtered.length; y++)
                        if (filtered[y].parent_id == temporary[i].id)
                            filtered[y].parent_id = temporary[i].parent_id;
                }
            }
            html = methods.createTree(filtered, 0, classes, is_open);
            var tree_code = $(html);
            // set last item line //
            tree_code.children("li").last().removeClass("middle").addClass("last");
            tree_code.find("ul").each(function () {
                if (is_open) {
                    $(this).show();
                }else{
                    $(this).hide();
                }
                $(this).children("li").last().removeClass("middle").addClass("last");
            });
            // click icon //
            tree_code.find(".tree-icon").on('click', function () {
                if ($(this).hasClass(classes.nochild)) {
                    $(this).unbind("click");
                } else if ($(this).hasClass(classes.closed)) {
                    $(this).removeClass(classes.closed).addClass(classes.opened);
                    $(this).parent().siblings().slideDown();
                }
                else if ($(this).hasClass(classes.opened)) {
                    $(this).removeClass(classes.opened).addClass(classes.closed);
                    $(this).parent().siblings().slideUp();
                }
                $(self).find('.selected').css({'background-color': the_color});
            });
            // click title //
            if (m_select) {
                tree_code.find(".tree-title").on('click', function () {
                    if ($(this).hasClass(classes.selected)) {
                        $(this).removeClass(classes.selected);
                    } else {
                        //tree_code.find(".tree-title").removeClass(classes.selected);
                        $(this).addClass(classes.selected);
                    }
                    $(self).find('.opened').css({'background-color': the_color});
                    $(self).find('.closed').css({'background-color': the_color});
                    $(self).find('.nochild').css({'background-color': the_color});
                    $(self).find('.selected').css({'background-color': the_color});
                });
            } else {
                tree_code.find(".tree-title").on('click', function () {
                    if ($(this).hasClass(classes.selected)) {
                        $(this).removeClass(classes.selected);
                    } else {
                        tree_code.find(".tree-title").removeClass(classes.selected);
                        $(this).addClass(classes.selected);
                    }
                    $(self).find('.selected').css({'background-color': the_color});
                });

            }
            self.find(".brick-tree").empty().append(tree_code);
            // get p_count
            tree_code.find("li").each(function () {
                $(this).find(".tree-title").attr("data-p_count", $(this).parents("li").length + 1);

                for (var i = 0; i < filtered.length; i++) {
                    if (filtered[i].parent_id == 0) {
                        if ($(this).find('.tree-title').attr('data-id') == filtered[i].id) {
                            $(this).removeClass('last');
                        }
                    }
                }

            });
            // get c_count
            if (col_ex) {
                tree_code.find("li").each(function () {
                    var c_count = 0;
                    $(this).find("li").each(function () {
                        if ($(this).find(".tree-title").data("p_count") > c_count) {
                            c_count = $(this).find(".tree-title").data("p_count");
                        }
                    });
                    $(this).find(".tree-title").attr("data-c_count", c_count);
                });

                // add contex menu
                var tree_item = self.find(".tree-main").children(".tree-title");
                var menu_item = $('<ul class="custom-menu"><li data-action="expand">Expand entire field</li><li data-action="collapse">Collapse Entire field</li></ul>');
                self.append(menu_item);
                // right click
                $(tree_item).on("contextmenu", function (event) {
                    event.stopPropagation();
                    var p_count = $(this).data("p_count");
                    event.preventDefault();
                    $(menu_item).finish().toggle(100).css({
                        top: event.pageY + "px",
                        left: event.pageX + "px"
                    });
                    $(document).one("click", function () {
                        $(menu_item).finish().toggle(100).css({
                            top: event.pageY + "px",
                            left: event.pageX + "px"
                        });
                    });
                    // menu click event
                    $(menu_item).find("li").on('click', function () {
                        switch ($(this).attr("data-action")) {
                            case "expand":
                                self.find(".tree-title").each(function () {
                                    if ($(this).data("p_count") <= p_count && $(this).data("c_count") >= p_count) {
                                        $(this).parents(".tree-main").siblings("ul").slideDown();
                                        $(this).siblings(".tree-icon").removeClass(classes.closed).addClass(classes.opened);
                                    }
                                });
                                break;
                            case "collapse":
                                self.find(".tree-title").each(function () {
                                    if ($(this).data("p_count") >= p_count) {
                                        $(this).parents(".tree-main").siblings("ul").slideUp();
                                        $(this).siblings(".tree-icon").removeClass(classes.opened).addClass(classes.closed);
                                    }
                                });
                                break;
                        }
                        $(menu_item).find("li").off();
                    });
                });
            }
        },
        createTree: function (filtered, parent_id, classes, is_open) {
            var html = "<ul>";
            for (var i = 0; i < filtered.length; i++) {
                if (filtered[i].parent_id == parent_id) {
                    var children = methods.createTree(filtered, filtered[i].id, classes, is_open);
                    if (children != "<ul style='display: none'></ul>") {
                        if (is_open) {
                            html += "<li class='middle'><div class='tree-main'><div class='tree-icon " + classes.opened + "'></div><div class='tree-title' data-id='" + filtered[i].id + "'>" + filtered[i].name + "</div></div>";
                        }
                        else {
                            html += "<li class='middle'><div class='tree-main'><div class='tree-icon " + classes.closed + "'></div><div class='tree-title' data-id='" + filtered[i].id + "'>" + filtered[i].name + "</div></div>";
                        }
                        html += children;
                    }
                    else {
                        html += "<li class='middle'><div class='tree-main'></div><div class='tree-icon " + classes.nochild + "'></div><div class='tree-title' data-id='" + filtered[i].id + "'>" + filtered[i].name + "</div>";
                    }
                    html += "</li>";
                }
            }
            html += "</ul>";
            return html;
        }
    };
    $.fn.filterTree = function (method) {
        if (methods[method]) {
            return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
        } else if (typeof method === 'object' || !method) {
            return methods.init.apply(this, arguments);
        } else {
            $.error('Unknown method ' + method);
        }
    };
})(jQuery);